<?php

namespace App\Controller\Admin;

use App\Controller\Admin\AppController;
use Cake\Event\Event;

/**
 * Downloads Controller
 *
 * @property \App\Model\Table\DownloadsTable $Downloads
 */
class DownloadsController extends AppController {

    /**
     * Index method
     *
     * @return void
     */
    public function index() {
        $this->paginate = [
            'limit' => 25000000
        ];
        $this->set('downloads', $this->paginate($this->Downloads));
        $this->set('_serialize', ['downloads']);
    }

    /**
     * Add method
     *
     * @return void Redirects on successful add, renders view otherwise.
     */
    public function add() {
        $download = $this->Downloads->newEntity();
        if ($this->request->is('post')) {
            if (!isset($this->request->data['image']['error']) ? $this->request->data['image']['error'] : TRUE) {
                $file = $this->Downloads->saveFile($download, $this->request->data['image'], $this->request->data['image_title']);
            }
            if ($file) {
                $this->Flash->success('The Document has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The Document could not be saved. Please, try again.');
            }
        }

        $this->set(compact('download'));
        $this->set('_serialize', ['download']);
        $this->set('isEdit', FALSE);
    }



	/**
     * Edit method
     *
     * @param string|null $id Category id.
     * @return void Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null) {
        $download = $this->Downloads->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $img = 1;
            if ($this->request->data['image']['name'] == "") {
                unset($this->request->data['image']);
                $img = 0;
            }
            $download = $this->Downloads->patchEntity($download, $this->request->data);
            if ($status = $this->Downloads->save($download)) {
                if ($img == 1) {
                    $file = $this->Downloads->saveFile($status, $this->request->data['image']);
                }
                $this->Flash->success('The elearingfirs has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The elearingfirs could not be saved. Please, try again.');
            }
        }
        $this->set('isEdit', TRUE);
        $this->set(compact('download'));
        $this->set('_serialize', ['download']);
    }

   






    /**
     * Delete method
     *
     * @param string|null $id Document id.
     * @return void Redirects to index.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function delete($id = null) {
        $this->request->allowMethod(['post', 'delete']);
        $download = $this->Downloads->get($id);
        if ($this->Downloads->delete($download)) {
            $root = ROOT;
            $finel_root = str_replace('admin', '', $root) . '/webroot/uploads/downloads/';
            @unlink($finel_root . $download->image);
            $this->Flash->success('The Download image has been deleted.');
        } else {
            $this->Flash->error('The Download image could not be deleted. Please, try again.');
        }
        return $this->redirect(['action' => 'index']);
    }

    public function status($id = null, $status = 0) {
        $download = $this->Downloads->get($id, [
            'contain' => []
        ]);
        if (!empty($download)) {
            $this->request->data['status'] = $status;
            $download = $this->Downloads->patchEntity($download, $this->request->data);
            if ($this->Downloads->save($download)) {
                $this->Flash->success('The Document has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The Document could not be saved. Please, try again.');
            }
        } else {
            $this->Flash->error('The Document could not be saved. Please, try again.');
        }
    }

    /**
     * 
     * Overrides the Default beforeRednder Method To add Breadcrumbs and other
     * Stuff
     * 
     * @param Event $event
     * @return void 
     */
    public function beforeRender(Event $event) {

        $this->breadcrumbs[] = [
            'label' => __('Document'),
            'link' => [
                'controller' => 'Downloads',
                'action' => 'index',
            ],
        ];

        switch ($this->request->params['action']) {
            default:
            case 'index':
                break;
            case 'add':
                $this->breadcrumbs[] = [
                    'label' => __('Add'),
                    'link' => NULL,
                ];
                break;
            case 'edit':
                $this->breadcrumbs[] = [
                    'label' => __('Edit'),
                ];

                $this->breadcrumbs[] = [
                    'label' => $this->downloadData->name,
                ];

                break;
        }
        parent::beforeRender($event);
    }

}
