<?php

namespace App\Controller\Admin;

use App\Controller\Admin\AppController;
use Cake\Controller\Component\CustomComponent;
use Cake\ORM\TableRegistry;
use Cake\ORM\find;
use Cake\View\CellTrait;

/**
 * Elearingfor Controller
 *
 * @property \App\Model\Table\ElearingforTable $elearingfot
 */
class ElearingforController extends AppController {

    public function initialize() {
        parent::initialize();
        $this->loadComponent('Custom');
        $this->Auth->allow('ls_elearingfor');
    }

    /**
     * Index method
     *
     * @return void
     */
    public function index() {
        $this->paginate = [
            'contain' => [],
        ];
        $this->set('elearingfor', $this->paginate($this->Elearingfor));
        $this->set('_serialize', ['elearingfor']);
    }

    /**
     * View method
     *
     * @param string|null $id Category id.
     * @return void
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function view($id = null) {
        $elearingfo = $this->Elearingfor->get($id, [
            'contain' => []
        ]);
        $this->set('elearingfo', $elearingfo);
        $this->set('_serialize', ['elearingfo']);
    }

    /**
     * Add method
     *
     * @return void Redirects on successful add, renders view otherwise.
     */
    public function add() {
        $elearingfo = $this->Elearingfor->newEntity();
        if ($this->request->is('post')) {
            //pr($this->request->data);die;
            $elearingfo = $this->Elearingfor->patchEntity($elearingfo, $this->request->data);
            if ($status = $this->Elearingfor->save($elearingfo)) {
                if (!isset($this->request->data['image']['error']) ? $this->request->data['image']['error'] : TRUE) {
                    $file = $this->Elearingfor->saveFile($status, $this->request->data['image']);
                }
                $this->Flash->success('The elearingfo has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The elearingfo could not be saved. Please, try again.');
            }
        }
        $this->set('isEdit', FALSE);
        $this->set(compact('elearingfo'));
        $this->set('_serialize', ['elearingfo']);
    }

    /**
     * Edit method
     *
     * @param string|null $id Category id.
     * @return void Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null) {
        $elearingfo = $this->Elearingfor->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $img = 1;
            if ($this->request->data['image']['name'] == "") {
                unset($this->request->data['image']);
                $img = 0;
            }
            $elearingfo = $this->Elearingfor->patchEntity($elearingfo, $this->request->data);
            if ($status = $this->Elearingfor->save($elearingfo)) {
                if ($img == 1) {
                    $file = $this->Elearingfor->saveFile($status, $this->request->data['image']);
                }
                $this->Flash->success('The elearingfo has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The elearingfo could not be saved. Please, try again.');
            }
        }
        $this->set('isEdit', TRUE);
        $this->set(compact('elearingfo'));
        $this->set('_serialize', ['elearingfo']);
    }

    public function status($id = null, $status = 0) {
        $elearingfo = $this->Elearingfor->get($id, [
            'contain' => []
        ]);
        if (!empty($elearingfo)) {
            $this->request->data['status'] = $status;
            $elearingfo = $this->Elearingfor->patchEntity($elearingfo, $this->request->data);
            if ($this->Elearingfor->save($elearingfo)) {
                $this->Flash->success('The elearingfo has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The elearingfo could not be saved. Please, try again.');
            }
        } else {
            $this->Flash->error('The elearingfo could not be saved. Please, try again.');
        }
    }

    /**
     * Delete method
     *
     * @param string|null $id Category id.
     * @return void Redirects to index.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function delete($id = null) {
        $this->request->allowMethod(['post', 'delete']);
        $elearingfo = $this->Elearingfor->get($id);
        if ($this->Elearingfor->delete($elearingfo)) {
            $this->Flash->success('The elearingfo has been deleted.');
        } else {
            $this->Flash->error('The elearingfo could not be deleted. Please, try again.');
        }
        return $this->redirect(['action' => 'index']);
    }

}
