<?php

namespace App\Controller\Admin;

use App\Controller\Admin\AppController;
use Cake\Event\Event;

/**
 * Galleryimages Controller
 *
 * @property \App\Model\Table\GalleryimagesTable $Galleryimages
 */
class GalleryimagesController extends AppController {

    /**
     * Index method
     *
     * @return void
     */
    public function index() {
        $this->paginate = [
            'limit' => 25000000
        ];
        $this->set('galleryimages', $this->paginate($this->Galleryimages));
        $this->set('_serialize', ['galleryimages']);
    }

    /**
     * Add method
     *
     * @return void Redirects on successful add, renders view otherwise.
     */
    public function add() {
        $galleryimage = $this->Galleryimages->newEntity();
        if ($this->request->is('post')) {
            if (!isset($this->request->data['image']['error']) ? $this->request->data['image']['error'] : TRUE) {
                $file = $this->Galleryimages->saveFile($galleryimage, $this->request->data['image'], $this->request->data['image_title']);
            }
            if ($file) {
                $this->Flash->success('The galleryimage has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The galleryimage could not be saved. Please, try again.');
            }
        }

        $this->set(compact('galleryimage'));
        $this->set('_serialize', ['galleryimage']);
        $this->set('isEdit', FALSE);
    }
	
	public function edit($id) {
        $galleryimage = $this->Galleryimages->get($id, [
            'contain' => []
        ]);

        if ($this->request->is(['patch', 'post', 'put'])) {
             if (!isset($this->request->data['image']['error']) ? $this->request->data['image']['error'] : TRUE) {
                $file = $this->Galleryimages->saveFile($galleryimage, $this->request->data['image'], $this->request->data['image_title']);
            }
            if ($file) {
                $this->Flash->success('The galleryimage has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The galleryimage could not be saved. Please, try again.');
            }
        }

        $this->countryData = $galleryimage;

        $this->set(compact('galleryimage'));
        $this->set('_serialize', ['galleryimage']);
        $this->set('isEdit', TRUE);
		$this->set('id',$id);

        $this->render('add');
    }
	

    /**
     * Delete method
     *
     * @param string|null $id Galleryimages id.
     * @return void Redirects to index.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function delete($id = null) {
        $this->request->allowMethod(['post', 'delete']);
        $galleryimage = $this->Galleryimages->get($id);
        if ($this->Galleryimages->delete($galleryimage)) {
            $root = ROOT;
            $finel_root = str_replace('admin', '', $root) . '/webroot/uploads/galleryimages/';
            @unlink($finel_root . $galleryimage->image);
            $this->Flash->success('The Gallery Image has been deleted.');
        } else {
            $this->Flash->error('The Gallery Image could not be deleted. Please, try again.');
        }
        return $this->redirect(['action' => 'index']);
    }
	
	

    public function status($id = null, $status = 0) {
        $galleryimage = $this->Galleryimages->get($id, [
            'contain' => []
        ]);
        if (!empty($galleryimage)) {
            $this->request->data['status'] = $status;
            $galleryimage = $this->Galleryimages->patchEntity($galleryimage, $this->request->data);
            if ($this->Galleryimages->save($galleryimage)) {
                $this->Flash->success('The Galleryimages has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The Galleryimages could not be saved. Please, try again.');
            }
        } else {
            $this->Flash->error('The Galleryimages could not be saved. Please, try again.');
        }
    }

    /**
     * 
     * Overrides the Default beforeRednder Method To add Breadcrumbs and other
     * Stuff
     * 
     * @param Event $event
     * @return void 
     */
    public function beforeRender(Event $event) {

        $this->breadcrumbs[] = [
            'label' => __('Galleryimages'),
            'link' => [
                'controller' => 'Galleryimages',
                'action' => 'index',
            ],
        ];

        switch ($this->request->params['action']) {
            default:
            case 'index':
                break;
            case 'add':
                $this->breadcrumbs[] = [
                    'label' => __('Add'),
                    'link' => NULL,
                ];
                break;
            case 'edit':
                $this->breadcrumbs[] = [
                    'label' => __('Edit'),
                ];

                $this->breadcrumbs[] = [
                    'label' => $this->galleryimageData->name,
                ];

                break;
        }
        parent::beforeRender($event);
    }

}
