<?php

namespace App\Controller\Admin;

use App\Controller\Admin\AppController;
use Cake\Event\Event;

/**
 * Mediaimages Controller
 *
 * @property \App\Model\Table\MediaimagesTable $Mediaimages
 */
class MediaimagesController extends AppController {

    /**
     * Index method
     *
     * @return void
     */
    public function index() {
        $this->paginate = [
            'limit' => 25000000
        ];
        $this->set('mediaimages', $this->paginate($this->Mediaimages));
        $this->set('_serialize', ['mediaimages']);
    }

    /**
     * Add method
     *
     * @return void Redirects on successful add, renders view otherwise.
     */
    public function add() {
        $mediaimage = $this->Mediaimages->newEntity();
        if ($this->request->is('post')) {
            if (!isset($this->request->data['image']['error']) ? $this->request->data['image']['error'] : TRUE) {
                $file = $this->Mediaimages->saveFile($mediaimage, $this->request->data['image']);
            }
            if ($file) {
                $this->Flash->success('The mediaimage has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The mediaimage could not be saved. Please, try again.');
            }
        }

        $this->set(compact('mediaimage'));
        $this->set('_serialize', ['mediaimage']);
        $this->set('isEdit', FALSE);
    }

    /**
     * Delete method
     *
     * @param string|null $id Mediaimage id.
     * @return void Redirects to index.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function delete($id = null) {
        $this->request->allowMethod(['post', 'delete']);
        $mediaimage = $this->Mediaimages->get($id);
        if ($this->Mediaimages->delete($mediaimage)) {
            $root = ROOT;
            $finel_root = str_replace('admin', '', $root) . '/webroot/uploads/mediaimages/';
            @unlink($finel_root . $mediaimage->image);
            $this->Flash->success('The Mediaimage image has been deleted.');
        } else {
            $this->Flash->error('The Mediaimage image could not be deleted. Please, try again.');
        }
        return $this->redirect(['action' => 'index']);
    }

    public function status($id = null, $status = 0) {
        $mediaimage = $this->Mediaimages->get($id, [
            'contain' => []
        ]);
        if (!empty($mediaimage)) {
            $this->request->data['status'] = $status;
            $mediaimage = $this->Mediaimages->patchEntity($mediaimage, $this->request->data);
            if ($this->Mediaimages->save($mediaimage)) {
                $this->Flash->success('The Mediaimage has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The Mediaimage could not be saved. Please, try again.');
            }
        } else {
            $this->Flash->error('The Mediaimage could not be saved. Please, try again.');
        }
    }

    /**
     * 
     * Overrides the Default beforeRednder Method To add Breadcrumbs and other
     * Stuff
     * 
     * @param Event $event
     * @return void 
     */
    public function beforeRender(Event $event) {

        $this->breadcrumbs[] = [
            'label' => __('Mediaimage'),
            'link' => [
                'controller' => 'Mediaimages',
                'action' => 'index',
            ],
        ];

        switch ($this->request->params['action']) {
            default:
            case 'index':
                break;
            case 'add':
                $this->breadcrumbs[] = [
                    'label' => __('Add'),
                    'link' => NULL,
                ];
                break;
            case 'edit':
                $this->breadcrumbs[] = [
                    'label' => __('Edit'),
                ];

                $this->breadcrumbs[] = [
                    'label' => $this->mediaimageData->name,
                ];

                break;
        }
        parent::beforeRender($event);
    }

}
