<?php

namespace App\Controller\Admin;

use App\Controller\Admin\AppController;
use Cake\Event\Event;
use Cake\Filesystem\Folder;
use Cake\Filesystem\File;

/**
 * Pdfuploads Controller
 *
 * @property \App\Model\Table\PdfuploadsTable $Pdfuploads
 */
class PdfuploadsController extends AppController {

    /**
     * Index method
     *
     * @return void
     */
    public function index() {
        $dir = new Folder(ROOT . DS . "webroot" . DS . "pdf");
        $files = $dir->find('.*');
        $fileNames = [];
        foreach ($files as $file) {
            $file = new File($dir->pwd() . DS . $file);
            $contents = $file->info();
            $fileNames[] = $contents['basename'];
            // $file->write('I am overwriting the contents of this file');
            // $file->append('I am adding to the bottom of this file.');
            // $file->delete(); // I am deleting this file
            $file->close(); // Be sure to close the file when you're done
        }
        $this->set(compact('fileNames'));
        $this->set('_serialize', ['fileNames']);
    }

    /**
     * Add method
     *
     * @return void Redirects on successful add, renders view otherwise.
     */
    public function add() {
        if ($this->request->is('post')) {
            $pdfupload = [];
            if (!isset($this->request->data['image']['error']) ? $this->request->data['image']['error'] : TRUE) {
                $file = $this->Pdfuploads->saveFile($pdfupload, $this->request->data['image']);
            }
            if ($file) {
                $this->Flash->success('The pdf has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The pdf could not be saved. Please, try again.');
            }
        }
        $this->set('isEdit', FALSE);
    }

    /**
     * Delete method
     *
     * @param string|null $id Pdfupload id.
     * @return void Redirects to index.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function delete($id = null) {
        $this->request->allowMethod(['post', 'delete']);
        $mediaimage = $this->Pdfuploads->get($id);
        if ($this->Pdfuploads->delete($mediaimage)) {
            $root = ROOT;
            $finel_root = str_replace('admin', '', $root) . '/webroot/uploads/mediaimages/';
            @unlink($finel_root . $mediaimage->image);
            $this->Flash->success('The Pdfupload image has been deleted.');
        } else {
            $this->Flash->error('The Pdfupload image could not be deleted. Please, try again.');
        }
        return $this->redirect(['action' => 'index']);
    }

    /**
     * 
     * Overrides the Default beforeRednder Method To add Breadcrumbs and other
     * Stuff
     * 
     * @param Event $event
     * @return void 
     */
    public function beforeRender(Event $event) {

        $this->breadcrumbs[] = [
            'label' => __('Pdfupload'),
            'link' => [
                'controller' => 'Pdfuploads',
                'action' => 'index',
            ],
        ];

        switch ($this->request->params['action']) {
            default:
            case 'index':
                break;
            case 'add':
                $this->breadcrumbs[] = [
                    'label' => __('Add'),
                    'link' => NULL,
                ];
                break;
            case 'edit':
                $this->breadcrumbs[] = [
                    'label' => __('Edit'),
                ];

                $this->breadcrumbs[] = [
                    'label' => $this->mediaimageData->name,
                ];

                break;
        }
        parent::beforeRender($event);
    }

}
