<?php

namespace App\Controller\Admin;

use App\Controller\Admin\AppController;
use Cake\Event\Event;

/**
 * Ppt Controller
 *
 * @property \App\Model\Table\PptTable $Ppt
 */
class PptController extends AppController {

    /**
     * Index method
     *
     * @return void
     */
    public function index() {
        $this->paginate = [
            'limit' => 25000000
        ];
        $this->set('ppt', $this->paginate($this->Ppt));
        $this->set('_serialize', ['ppt']);
    }

    /**
     * Add method
     *
     * @return void Redirects on successful add, renders view otherwise.
     */
    public function add() {
        $ppt = $this->Ppt->newEntity();
        if ($this->request->is('post')) {
            if (!isset($this->request->data['image']['error']) ? $this->request->data['image']['error'] : TRUE) {
                $file = $this->Ppt->saveFile($ppt, $this->request->data['image']);
            }
            if ($file) {
                $this->Flash->success('The ppt has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The ppt could not be saved. Please, try again.');
            }
        }

        $this->set(compact('ppt'));
        $this->set('_serialize', ['ppt']);
        $this->set('isEdit', FALSE);
    }

    /**
     * Delete method
     *
     * @param string|null $id Mediaimage id.
     * @return void Redirects to index.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function delete($id = null) {
        $this->request->allowMethod(['post', 'delete']);
        $ppt = $this->Ppt->get($id);
        if ($this->Ppt->delete($ppt)) {
            $root = ROOT;
            $finel_root = str_replace('admin', '', $root) . '/webroot/uploads/ppt/';
            @unlink($finel_root . $ppt->image);
            $this->Flash->success('The Ppt image has been deleted.');
        } else {
            $this->Flash->error('The Ppt image could not be deleted. Please, try again.');
        }
        return $this->redirect(['action' => 'index']);
    }

    public function status($id = null, $status = 0) {
        $ppt = $this->Ppt->get($id, [
            'contain' => []
        ]);
        if (!empty($ppt)) {
            $this->request->data['status'] = $status;
            $ppt = $this->Ppt->patchEntity($ppt, $this->request->data);
            if ($this->Ppt->save($ppt)) {
                $this->Flash->success('The Ppt has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The Ppt could not be saved. Please, try again.');
            }
        } else {
            $this->Flash->error('The Ppt could not be saved. Please, try again.');
        }
    }

    /**
     * 
     * Overrides the Default beforeRednder Method To add Breadcrumbs and other
     * Stuff
     * 
     * @param Event $event
     * @return void 
     */
    public function beforeRender(Event $event) {

        $this->breadcrumbs[] = [
            'label' => __('Ppt'),
            'link' => [
                'controller' => 'Ppt',
                'action' => 'index',
            ],
        ];

        switch ($this->request->params['action']) {
            default:
            case 'index':
                break;
            case 'add':
                $this->breadcrumbs[] = [
                    'label' => __('Add'),
                    'link' => NULL,
                ];
                break;
            case 'edit':
                $this->breadcrumbs[] = [
                    'label' => __('Edit'),
                ];

                $this->breadcrumbs[] = [
                    'label' => $this->pptData->name,
                ];

                break;
        }
        parent::beforeRender($event);
    }

}
