<?php

namespace App\Controller\Admin;

use App\Controller\Admin\AppController;
use Cake\Event\Event;

/**
 * Sliderimages Controller
 *
 * @property \App\Model\Table\SliderimagesTable $Sliderimages
 */
class SliderimagesController extends AppController {

    /**
     * Index method
     *
     * @return void
     */
    public function index() {
        $this->paginate = [
            'limit' => 25000
        ];
        $this->set('sliderimages', $this->paginate($this->Sliderimages));
        $this->set('_serialize', ['sliderimages']);
    }

    /**
     * Add method
     *
     * @return void Redirects on successful add, renders view otherwise.
     */
    public function add() {
        $sliderimage = $this->Sliderimages->newEntity();
        if ($this->request->is('post')) {
            if (!isset($this->request->data['image']['error']) ? $this->request->data['image']['error'] : TRUE) {
                $file = $this->Sliderimages->saveFile($sliderimage, $this->request->data['image'], $this->request->data['slider_id'], $this->request->data['image_link']);
            }
            if ($file) {
                $this->Flash->success('The sliderimage has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The sliderimage could not be saved. Please, try again.');
            }
        }

        $this->set(compact('sliderimage'));
        $this->set('_serialize', ['sliderimage']);
        $this->set('isEdit', FALSE);
    }
	
	
	
	public function edit($id) {
        $sliderimage = $this->Sliderimages->get($id, [
            'contain' => []
        ]);

        if ($this->request->is(['patch', 'post', 'put'])) {
              if (!isset($this->request->data['image']['error']) ? $this->request->data['image']['error'] : TRUE) {
                $file = $this->Sliderimages->saveFile($sliderimage, $this->request->data['image'], $this->request->data['slider_id'], $this->request->data['image_link']);
            }
            if ($file) {
                $this->Flash->success('The sliderimage has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The sliderimage could not be saved. Please, try again.');
            }
        }

        $this->countryData = $sliderimage;

        $this->set(compact('sliderimage'));
        $this->set('_serialize', ['sliderimage']);
        $this->set('isEdit', TRUE);
		$this->set('id',$id);

        $this->render('add');
    }
	
	

    /**
     * Delete method
     *
     * @param string|null $id Sliderimage id.
     * @return void Redirects to index.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function delete($id = null) {
        $this->request->allowMethod(['post', 'delete']);
        $sliderimage = $this->Sliderimages->get($id);
        if ($this->Sliderimages->delete($sliderimage)) {
            $root = ROOT;
            $finel_root = str_replace('admin', '', $root) . '/webroot/uploads/sliderimages/';
            @unlink($finel_root . $sliderimage->image);
            $this->Flash->success('The Slider image has been deleted.');
        } else {
            $this->Flash->error('The Slider image could not be deleted. Please, try again.');
        }
        return $this->redirect(['action' => 'index']);
    }

    public function status($id = null, $status = 0) {
        $sliderimage = $this->Sliderimages->get($id, [
            'contain' => []
        ]);
        if (!empty($sliderimage)) {
            $this->request->data['status'] = $status;
            $sliderimage = $this->Sliderimages->patchEntity($sliderimage, $this->request->data);
            if ($this->Sliderimages->save($sliderimage)) {
                $this->Flash->success('The Sliderimage has been saved.');
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error('The Sliderimage could not be saved. Please, try again.');
            }
        } else {
            $this->Flash->error('The Sliderimage could not be saved. Please, try again.');
        }
    }

    /**
     * 
     * Overrides the Default beforeRednder Method To add Breadcrumbs and other
     * Stuff
     * 
     * @param Event $event
     * @return void 
     */
    public function beforeRender(Event $event) {

        $this->breadcrumbs[] = [
            'label' => __('Sliderimage'),
            'link' => [
                'controller' => 'sliderimages',
                'action' => 'index',
            ],
        ];

        switch ($this->request->params['action']) {
            default:
            case 'index':
                break;
            case 'add':
                $this->breadcrumbs[] = [
                    'label' => __('Add'),
                    'link' => NULL,
                ];
                break;
            case 'edit':
                $this->breadcrumbs[] = [
                    'label' => __('Edit'),
                ];

                $this->breadcrumbs[] = [
                    'label' => $this->sliderimageData->name,
                ];

                break;
        }
        parent::beforeRender($event);
    }

}
